/// <reference types="node" />
import * as fs from "fs";
export declare namespace VueRouteGen {
    interface Import {
        file: string;
        name: string[];
    }
    interface RouteEnum {
        fileName: string;
        constName: string;
        name: string;
        path: string;
        parent?: string;
        show: boolean;
    }
}
export interface RouteConfig {
    glob: string[];
    root: string;
    file: string;
}
export interface PageConfig {
    pageName: string;
    path: string;
    title: string;
    parent?: string;
    show: boolean;
}
export interface FileCache {
    fileName: string;
    lastModified: number;
    exports: PageConfig[];
}
export declare class Programer {
    private config;
    cacher: Map<string, FileCache>;
    watcher: fs.FSWatcher;
    routeFile: string;
    routePath: string;
    constructor(config: RouteConfig);
    init(): Promise<void>;
    private resloveRoutePath;
    private parseFile;
    private importPath;
    private RouteNames;
    private CachedNames;
    private getConstName;
    private emit;
    private generateRoute;
}
