"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("fs"));
var ts = __importStar(require("typescript"));
var glob_utils_1 = require("./glob-utils");
var path_1 = require("path");
var tsutil_1 = require("@foolishchow/tsutil");
var debounce_1 = require("./debounce");
var route_template_1 = require("./route-template");
var Programer = /** @class */ (function () {
    function Programer(config) {
        this.config = config;
        this.cacher = new Map();
        this.RouteNames = new Set();
        this.CachedNames = new Map();
        this.routeFile = path_1.resolve(process.cwd(), config.file);
        this.routePath = path_1.dirname(this.routeFile);
        this.emit = debounce_1.debounce(this.emit, 500);
        this.init();
    }
    Programer.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var watcher;
            var _this = this;
            return __generator(this, function (_a) {
                watcher = glob_utils_1.Watch(this.config.glob);
                watcher.on("change", function (path, stat) {
                    _this.parseFile(path, Date.now());
                });
                watcher.on("add", function (path, stat) {
                    // console.info("add", path)
                    _this.parseFile(path, Date.now());
                });
                watcher.on("unlink", function (path, stat) {
                    _this.cacher.delete(path);
                });
                return [2 /*return*/];
            });
        });
    };
    Programer.prototype.resloveRoutePath = function (fileName, path) {
        if (path === void 0) { path = ""; }
        var routePath = fileName.replace(this.config.root, "").replace(/\.tsx?$/, "").split(path_1.sep).join("/") + "/" + path;
        return routePath.replace(/\/+/g, "/").replace(/\/index\/?$/, "/");
    };
    Programer.prototype.parseFile = function (fileName, time) {
        var _this = this;
        var content = fs.readFileSync(path_1.resolve(process.cwd(), fileName)).toString();
        var sourcefile = ts.createSourceFile(fileName, content, ts.ScriptTarget.ESNext);
        var pageConfigs = tsutil_1.$(sourcefile).find("ClassDeclaration").map(function (node) {
            var ClassDeclaration = node;
            if (isExported(ClassDeclaration)) {
                var name_1 = (ClassDeclaration.name);
                if (name_1) {
                    var tags = parseJsDoc(ClassDeclaration);
                    if (tags.show == undefined)
                        tags.show = true;
                    if (tags.ignore) {
                        _this.cacher.delete(fileName);
                    }
                    else {
                        var config = {
                            path: _this.resloveRoutePath(fileName, (tags.path || "").toString()),
                            pageName: name_1.text,
                            title: tags.title.toString() || "",
                            show: tags.show
                        };
                        if (tags.parent) {
                            config.parent = tags.parent.toString();
                        }
                        return config;
                    }
                }
            }
        }).filter(function (s) { return s; });
        if (pageConfigs.length > 0) {
            var config = {
                fileName: fileName,
                lastModified: time,
                exports: pageConfigs
            };
            this.cacher.set(fileName, config);
            this.emit();
        }
    };
    Programer.prototype.importPath = function (filename) {
        var path = path_1.relative(this.routePath, path_1.resolve(process.cwd(), filename)).replace(/\.tsx?$/, '');
        if (!path.startsWith('.')) {
            path = './' + path;
        }
        return path.replace(/\/index$/, "");
    };
    Programer.prototype.getConstName = function (name, constName) {
        if (!constName)
            constName = name;
        if (this.RouteNames.has(constName)) {
            return this.getConstName(name, constName + "_1");
        }
        this.CachedNames.set(name, constName);
        this.RouteNames.add(constName);
        return name;
    };
    Programer.prototype.emit = function () {
        var _this = this;
        this.RouteNames = new Set();
        this.CachedNames = new Map();
        var Import = [];
        var RoutePath = [];
        route_template_1.LoopMap(this.cacher, function (key, item) {
            Import.push({
                file: _this.importPath(item.fileName),
                name: item.exports.map(function (e) { return _this.getConstName(e.pageName); })
            });
        });
        route_template_1.LoopMap(this.cacher, function (key, item) {
            item.exports.forEach(function (route) {
                RoutePath.push({
                    fileName: item.fileName,
                    name: route.title,
                    constName: _this.CachedNames.get(route.pageName),
                    path: route.path,
                    parent: route.parent ? _this.CachedNames.get(route.parent) : undefined,
                    show: route.show
                });
            });
        });
        var AppRoute = this.generateRoute(RoutePath);
        var content = route_template_1.Template(Import, RoutePath, AppRoute.route, AppRoute.menu);
        fs.writeFileSync(this.routeFile, content);
    };
    Programer.prototype.generateRoute = function (RoutePath) {
        var RoutePaths = {};
        var Routes = {};
        var rootRoute = [];
        var MenuRoutes = {};
        var RootMenuRoutes = [];
        RoutePath.map(function (item) {
            RoutePaths[item.constName] = item.path;
            Routes[item.constName] = ({
                name: item.name,
                path: item.path,
                component: "class " + item.constName + " {}"
            });
            if (item.show) {
                MenuRoutes[item.constName] = ({
                    name: item.name,
                    path: item.path
                });
            }
        });
        RoutePath.filter(function (e) { return e.parent; }).forEach(function (e) {
            var parentName = e.parent, childName = e.constName, parenetPath = RoutePaths[parentName], childPath = RoutePaths[childName], child = Routes[childName], parent = Routes[parentName];
            // childPath = ("/" + childPath.replace(parenetPath, "")).replace(/^\/+/, "/").replace(/\/$/g, "")
            child.path = childPath;
            (parent.children || (parent.children = [])).push(child);
            if (child.show) {
                var MenuParent = MenuRoutes[parentName];
                if (MenuParent) {
                    (MenuParent.children || (MenuParent.children = [])).push(MenuRoutes[childName]);
                }
            }
        });
        RoutePath.filter(function (e) { return !e.parent; })
            .forEach(function (item) {
            rootRoute.push(Routes[item.constName]);
        });
        RoutePath.filter(function (e) { return !e.parent && e.show; })
            .forEach(function (item) {
            RootMenuRoutes.push(MenuRoutes[item.constName]);
        });
        var route = JSON.stringify(rootRoute, null, 4);
        var menuRoute = JSON.stringify(RootMenuRoutes, null, 4);
        return {
            route: route.replace(/"class\s(\w+)\s{}"/g, function (w, $1) { return $1; }),
            menu: menuRoute.replace(/"class\s(\w+)\s{}"/g, function (w, $1) { return $1; }),
        };
    };
    return Programer;
}());
exports.Programer = Programer;
var isExported = function (node) {
    return node.modifiers && node.modifiers.some(function (s) { return s.kind == ts.SyntaxKind.ExportKeyword; });
};
var parseJsDoc = function (node) {
    // @ts-ignore
    if (!node.jsDoc)
        return {};
    var docs = node.jsDoc;
    var result = {};
    docs.forEach(function (doc) {
        if (doc.tags)
            doc.tags.forEach(function (tag) {
                var name = tag.tagName.text;
                var value = tag.comment || "";
                if (name == "show") {
                    result[name] = value == "false" ? false : true;
                }
                else if (name == "ignore") {
                    result[name] = true;
                }
                else {
                    result[name] = value;
                }
            });
    });
    return result;
};
// Start the watcher
process.on("uncaughtException", function (e) {
    console.info(e);
});
